Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.1.0 E18814-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.tangosol.util.filter
Class InKeySetFilter

`java.lang.Object
com.tangosol.util.Base
com.tangosol.util.BitHelper
com.tangosol.util.ExternalizableHelper
com.tangosol.util.filter.InKeySetFilter`

All Implemented Interfaces:
  ExternalizableLite, PortableObject, Filter, EntryFilter, IndexAwareFilter, java.io.Serializable

      public class InKeySetFilter

extends ExternalizableHelper
implements IndexAwareFilter, ExternalizableLite, PortableObject

Filter that limits the underlying filter evaluation only to the specified set of keys.

Author:
  gg 2006.06.12

Constructor Summary
`InKeySetFilter()` Default constructor (necessary for the ExternalizableLite interface).
`InKeySetFilter(Filter filter, java.util.Set setKeys)` Construct an InFilter for testing "In" condition.

Method Summary
`Filter` | `applyIndex(java.util.Map mapIndexes, java.util.Set setKeys)` Filter remaining keys using a Map of available indexes.
`int` | `calculateEffectiveness(java.util.Map mapIndexes, java.util.Set setKeys)` Given a Map of available indexes, determine if this IndexAwareFilter can use any of the indexes to assist in its processing, and if so, determine how effective the use of that index would be.
`void` | `ensureConverted(Converter converter)` Ensure that the underlying keys are converted using the specified converter.
`boolean` | `evaluate(java.lang.Object o)` Apply the test to the object.
`boolean` | `evaluateEntry(java.util.Map.Entry entry)` Apply the test to a Map Entry.
`Filter` | `getFilter()` Obtain the underying Filter.
`void` | `readExternal(java.io.DataInput in)` Restore the contents of this object by loading the object's state from the passed DataInput object.
`void` | `readExternal(PofReader in)` Restore the contents of a user type instance by reading its state using the specified PofReader object.
`java.lang.String` | `toString()` Return a human-readable description for this Filter.
`void` | `writeExternal(java.io.DataOutput out)` Save the contents of this object by storing the object's state into the passed DataOutput object.
`void` | `writeExternal(PofWriter out)` Save the contents of a POF user type instance by writing its state using the specified PofWriter object.

Methods inherited from class com.tangosol.util.BitHelper
`countBits, countBits, countBits, indexOfLSB, indexOfLSB, indexOfLSB, indexOfMSB, indexOfMSB, indexOfMSB, rotateLeft, rotateLeft, rotateLeft, rotateRight, rotateRight, rotateRight, toBitString, toBitString, toBitString`

Constructor Detail

### InKeySetFilter

    public InKeySetFilter()

  Default constructor (necessary for the ExternalizableLite interface).

### InKeySetFilter

    public InKeySetFilter(Filter filter,
                          java.util.Set setKeys)

  Construct an InFilter for testing "In" condition.
  Parameters:
    `filter` - the underlying filter
    `setKeys` - the set of keys to limit the filter evaluation to

Method Detail

### evaluate

    public boolean evaluate(java.lang.Object o)

  Apply the test to the object.
  Specified by:
    `evaluate` in interface `Filter`
  Parameters:
    `o` - the object to test
  Returns:
    true if the test passes, false otherwise

### evaluateEntry

    public boolean evaluateEntry(java.util.Map.Entry entry)

  Apply the test to a Map Entry.
  Specified by:
    `evaluateEntry` in interface `EntryFilter`
  Parameters:
    `entry` - the Map Entry to evaluate; never null
  Returns:
    true if the test passes, false otherwise

### calculateEffectiveness

    public int calculateEffectiveness(java.util.Map mapIndexes,
                                      java.util.Set setKeys)

  Given a Map of available indexes, determine if this IndexAwareFilter can use any of the indexes to assist in its processing, and if so, determine how effective the use of that index would be. The returned value is an effectiveness estimate of how well this filter can use the specified indexes to filter the specified keys. An operation that requires no more than a single access to the index content (i.e. Equals, NotEquals) has an effectiveness of one. Evaluation of a single entry is assumed to have an effectiveness that depends on the index implementation and is usually measured as a constant number of the single operations. This number is referred to as evaluation cost. If the effectiveness of a filter evaluates to a number larger than the `keySet.size() * <evaluation cost>` then a user could avoid using the index and iterate through the keySet calling `evaluate` rather then `applyIndex`.
  Specified by:
    `calculateEffectiveness` in interface `IndexAwareFilter`
  Parameters:
    `mapIndexes` - the available `MapIndex` objects keyed by the related ValueExtractor; read-only
    `setKeys` - the set of keys that will be filtered; read-only
  Returns:
    an effectiveness estimate of how well this filter can use the specified indexes to filter the specified keys

### applyIndex

    public Filter applyIndex(java.util.Map mapIndexes,
                             java.util.Set setKeys)

  Filter remaining keys using a Map of available indexes. The filter is responsible for removing all keys from the passed set of keys that the applicable indexes can prove should be filtered. If the filter does not fully evaluate the remaining keys using just the index information, it must return a filter (which may be an `EntryFilter`) that can complete the task using an iterating implementation. If, on the other hand, the filter does fully evaluate the remaining keys using just the index information, then it should return null to indicate that no further filtering is necessary.
  Specified by:
    `applyIndex` in interface `IndexAwareFilter`
  Parameters:
    `mapIndexes` - the available `MapIndex` objects keyed by the related ValueExtractor; read-only
    `setKeys` - the mutable set of keys that remain to be filtered
  Returns:
    a `Filter` object (which may be an `EntryFilter`) that can be used to process the remaining keys, or null if no additional filter processing is necessary

### getFilter

    public Filter getFilter()

  Obtain the underying Filter.
  Returns:
    the underlying filter

### ensureConverted

    public void ensureConverted(Converter converter)

  Ensure that the underlying keys are converted using the specified converter. This method is intended to be used exclusively by the partitioned cache service in a scenario when cache keys to evaluate by this filter exist in internal form.
  Parameters:
    `converter` - the converter that should be used for key conversions

### toString

    public java.lang.String toString()

  Return a human-readable description for this Filter.
  Returns:
    a String description of the Filter

### readExternal

    public void readExternal(java.io.DataInput in)
                      throws java.io.IOException

  Restore the contents of this object by loading the object's state from the passed DataInput object.
  Specified by:
    `readExternal` in interface `ExternalizableLite`
  Parameters:
    `in` - the DataInput stream to read data from in order to restore the state of this object
  Throws:
    `java.io.IOException` - if an I/O exception occurs
    `java.io.NotActiveException` - if the object is not in its initial state, and therefore cannot be deserialized into

### writeExternal

    public void writeExternal(java.io.DataOutput out)
                       throws java.io.IOException

  Save the contents of this object by storing the object's state into the passed DataOutput object.
  Specified by:
    `writeExternal` in interface `ExternalizableLite`
  Parameters:
    `out` - the DataOutput stream to write the state of this object to
  Throws:
    `java.io.IOException` - if an I/O exception occurs

### readExternal

    public void readExternal(PofReader in)
                      throws java.io.IOException

  Restore the contents of a user type instance by reading its state using the specified PofReader object.
  Specified by:
    `readExternal` in interface `PortableObject`
  Parameters:
    `in` - the PofReader from which to read the object's state
  Throws:
    `java.io.IOException` - if an I/O error occurs

### writeExternal

    public void writeExternal(PofWriter out)
                       throws java.io.IOException

  Save the contents of a POF user type instance by writing its state using the specified PofWriter object.
  Specified by:
    `writeExternal` in interface `PortableObject`
  Parameters:
    `out` - the PofWriter to which to write the object's state
  Throws:
    `java.io.IOException` - if an I/O error occurs

Skip navigation links

Overview | Package | Class | Tree | Index | Help
| Oracle® Coherence Java API Reference Release 3.6.1.0 E18814-01
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2000, 2010, Oracle and/or its affiliates. All rights reserved.